;; Tests for weak pointers and static vectors

(defpackage :weak-pointer-tests
  (:use :cl :lisp-unit))

(in-package "WEAK-POINTER-TESTS")

(define-test weak-pointer.load
    (:tag :issues)
  (let ((test-file #.(merge-pathnames "resources/test-243-1" cl:*load-pathname*)))
    (format t "test-file = ~A~%" test-file)
    (assert-true (load test-file))))

(define-test weak-pointer-ref.gc
    (:tag :issues)
  (assert-equal 2 (length lisp::*static-vectors*))
  (assert-true (nth-value 1 (ext:weak-pointer-value cl-user::*ref*)))
  (ext:gc :full t))

(define-test weak-pointer-ref.broken
    (:tag :issues)
  (assert-false (nth-value 1 (ext:weak-pointer-value cl-user::*ref*)))
  (assert-equal 1 (length lisp::*static-vectors*)))
